## libthrust 1.9.10-1

=== debian/changelog ===
libthrust (1.9.10-1-1) unstable; urgency=medium

  * New upstream release 1.9.10-1 (CUDA 11.1).
  * cub is a separate project since 1.9.8.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Aug 2020 21:37:56 +0200

libthrust (1.9.7-1-1) unstable; urgency=medium

  * New upstream release 1.9.7-1 (CUDA 10.2 for Tegra).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Jul 2020 18:58:30 +0200

libthrust (1.9.7-1) unstable; urgency=medium

  * New upstream snapshot 1.9.7 (CUDA 10.2).
    (Last commit before removal of the embedded cub.)
  * Switch to debhelper-compat (= 13).
  * Bump Standards-Version to 4.5.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Jul 2020 10:54:11 +0200
