=== debian/changelog ===
libthrust (1.11.0-1) unstable; urgency=medium

  * New upstream release 1.11.0.
  * New upstream release 1.10.0 (CUDA 11.2).
  * Update upstream location.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 08 Jan 2021 15:11:26 +0100
