=== debian/watch ===
version=4

https://github.com/NVIDIA/thrust/releases .*/(\d+.*)\.tar\.gz
