=== testing/CMakeLists.txt ===
--- 
+++ 
@@ -17,38 +17,29 @@
 # Generate testing framework libraries:
 add_subdirectory(unittest)
 
-# List of tests that aren't implemented for all backends, but are implemented for CUDA.
-set(partially_implemented_CUDA
-  async_copy
-  async_for_each
-  async_reduce
-  async_reduce_into
-  async_sort
-  async_transform
-  event
-  future
-)
+# Some tests only support certain host.device configurations. Use this macro to
+# declare allowed configurations. If not specified, all host.device config are
+# used.
+set(restricted_tests)
+macro(thrust_declare_test_restrictions test_name)
+  list(APPEND restricted_tests ${test_name})
+  list(APPEND ${test_name}_host.device_allowed ${ARGN})
+endmacro()
 
-# List of tests that aren't implemented for all backends, but are implemented for CPP.
-set(partially_implemented_CPP
-)
+# Async/future/event tests only support the CUDA backend:
+thrust_declare_test_restrictions(async_copy        CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(async_for_each    CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(async_reduce      CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(async_reduce_into CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(async_sort        CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(async_transform   CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(event             CPP.CUDA OMP.CUDA TBB.CUDA)
+thrust_declare_test_restrictions(future            CPP.CUDA OMP.CUDA TBB.CUDA)
 
-# List of tests that aren't implemented for all backends, but are implemented for TBB.
-set(partially_implemented_TBB
-)
-
-# List of tests that aren't implemented for all backends, but are implemented for OMP.
-set(partially_implemented_OMP
-)
-
-# List of all partially implemented tests.
-set(partially_implemented
-  ${partially_implemented_CUDA}
-  ${partially_implemented_CPP}
-  ${partially_implemented_TBB}
-  ${partially_implemented_OMP}
-)
-list(REMOVE_DUPLICATES partially_implemented)
+# This test is incompatible with TBB and OMP, since it requires special per-device
+# handling to process exceptions in a device function, which is only implemented
+# for CUDA.
+thrust_declare_test_restrictions(unittest_static_assert CPP.CPP CPP.CUDA)
 
 ## thrust_add_test
 #
@@ -84,7 +75,7 @@
   set(test_meta_target thrust.all.test.${test_name})
 
   add_executable(${test_target} "${real_test_src}")
-  target_link_libraries(${test_target} ${config_framework_target})
+  target_link_libraries(${test_target} PRIVATE ${config_framework_target})
   target_include_directories(${test_target} PRIVATE "${Thrust_SOURCE_DIR}/testing")
   thrust_clone_target_properties(${test_target} ${thrust_target})
 
@@ -116,7 +107,13 @@
   # to allow custom property modifications.
   get_filename_component(test_cmake_script "${test_src}" NAME_WLE)
   set(test_cmake_script "${CMAKE_CURRENT_LIST_DIR}/${test_cmake_script}.cmake")
-  if (EXISTS "${test_cmake_script}")
+  # Use a glob so we can detect if this changes:
+  file(GLOB test_cmake_script
+    RELATIVE "${CMAKE_CURRENT_LIST_DIR}"
+    CONFIGURE_DEPENDS
+    "${test_cmake_script}"
+  )
+  if (test_cmake_script) # Will be non-empty only if the script exists
     include("${test_cmake_script}")
   endif()
 endfunction()
@@ -129,15 +126,18 @@
 
 # Add common tests to all configs:
 foreach(thrust_target IN LISTS THRUST_TARGETS)
+  thrust_get_target_property(config_host ${thrust_target} HOST)
   thrust_get_target_property(config_device ${thrust_target} DEVICE)
   thrust_get_target_property(config_prefix ${thrust_target} PREFIX)
 
   foreach(test_src IN LISTS test_srcs)
     get_filename_component(test_name "${test_src}" NAME_WLE)
-    if ("${test_name}" IN_LIST partially_implemented)
-      # This test is partially implemented on _some_ backends...
-      if (NOT "${test_name}" IN_LIST partially_implemented_${config_device})
-        # ...but not on the current one.
+
+    # Is this test restricted to only certain host/device combinations?
+    if(${test_name} IN_LIST restricted_tests)
+      # Is the current host/device combination supported?
+      if (NOT "${config_host}.${config_device}" IN_LIST
+            ${test_name}_host.device_allowed)
         continue()
       endif()
     endif()
@@ -151,6 +151,7 @@
 endforeach()
 
 # Add specialized tests:
+add_subdirectory(async)
 add_subdirectory(cmake)
 add_subdirectory(cpp)
 add_subdirectory(cuda)
