=== testing/cmake/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,14 @@
 thrust_update_system_found_flags()
+
+set(extra_cmake_flags)
+
+# Need to pass these when testing NVC++.
+if ("NVCXX" STREQUAL "${CMAKE_CUDA_COMPILER_ID}")
+  set(extra_cmake_flags
+    -D "CMAKE_CUDA_COMPILER_ID=${CMAKE_CUDA_COMPILER_ID}"
+    -D "CMAKE_CUDA_COMPILER_FORCED=${CMAKE_CUDA_COMPILER_FORCED}"
+  )
+endif()
 
 if (THRUST_CPP_FOUND AND THRUST_CUDA_FOUND)
   # Test that we can use `find_package` on an installed Thrust:
@@ -13,5 +23,15 @@
       -D "CMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
       -D "CMAKE_CUDA_COMPILER=${CMAKE_CUDA_COMPILER}"
       -D "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
+      ${extra_cmake_flags}
   )
 endif()
+
+# Check that namespace macros are used correctly:
+add_test(
+  NAME thrust.test.cmake.check_namespace
+  COMMAND
+    "${CMAKE_COMMAND}"
+      -D "Thrust_SOURCE_DIR=${Thrust_SOURCE_DIR}"
+      -P "${CMAKE_CURRENT_LIST_DIR}/check_namespace.cmake"
+)
