=== debian/changelog ===
libthrust (1.14.0-1) unstable; urgency=medium

  * New upstream release 1.14.0.
  * New upstream release 1.13.1 (CUDA 11.5).
  * New upstream release 1.13.0.
  * New upstream release 1.12.1 (CUDA 11.4).
  * New upstream release 1.12.0.
  * Bump Standards-Version to 4.6.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 26 Sep 2021 22:36:56 +0200
