=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/NVIDIA/thrust
 Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
 Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git
